Showing posts with label LeetCode - Bit. Show all posts
Showing posts with label LeetCode - Bit. Show all posts

LeetCode 342 - Power of Four


https://www.hrwhisper.me/leetcode-power-four/
Given an integer (signed 32 bits), write a function to check whether it is a power of 4.
Example:
Given num = 16, return true. Given num = 5, return false.
Follow up: Could you solve it without loops/recursion?

https://segmentfault.com/a/1190000003481153
时间 O(1) 空间 O(1)

思路

1   0 0000 0001
4   0 0000 0100
16  0 0001 0000
64  0 0100 0000
256 1 0000 0000
仔细观察可以发现,4的幂的二进制形式中,都是在从后向前的奇数位有一个1,所以只要一个数符合这个模式,就是4的幂
private boolean bruteForceBit(long num){
    boolean res = false;
    if(num <= 0) return res;
    for(int i = 1; i <= 64; i++){
        // 如果该位是0,则不操作
        if((num & 1) == 1){
            // 如果是偶数位为1,说明不是4的幂
            if(i % 2 == 0) return false;
            // 如果是奇数位为1,如果之前已经有1了,则也不是4的幂
            if(res){
                return false;
            } else {
            // 如果是第一次出现技术位为1,则可能是4的幂
                res = true;
            }
        }
        num = num >>> 1;
    }
    return res;
}
http://www.programcreek.com/2015/04/leetcode-power-of-four-java/
public boolean isPowerOfFour(int num) {
    int count0=0;
    int count1=0;
 
    while(num>0){
        if((num&1)==1){
            count1++;
        }else{
            count0++;
        }
        num>>=1;
    }
 
    return count1==1 && (count0%2==0);
}

在Power of Two中,我们有一个解法是通过判断n & (n - 1)是否为0来判断是否为2的幂,因为4的幂肯定也是2的幂,所以这也可以用到这题来。那4的幂和2的幂有什么区别呢?根据上一个解法,我们知道4的幂的1只可能在奇数位,而2的幂的1可能在任意位,所以我们只要判断是不是奇数位是1就行了。因为根据n & (n - 1)我们已经筛出来那些只有1个1的数了,所以和010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101 也就是0x5555555555555555相与就能知道1是在奇数位还是偶数位了。
power of two的时候,我们用 n &(n-1) ==0 来判断是否是2的次方数,这里也先判断一下是否为2的次方数。然后再把不是4的次方数排除掉,比如8.
我们来看看2的次方数的规律:
我们发现,每次不过是将1向左移动一个位置,然后低位补0(这不是废话么= =|||)
那么4的次方数就是将1向左移动两个位置喽 (还是废话(╯-_-)╯╧╧)
观察一下位置,4的次方中的1只出现在奇数的位置上!就是说,上面的二进制从右往左,第1,3,5,……位置上。
So,如果我们与上一个可以在奇数上面选择位置的数,也就是 0101 0101 ……那么就把不是4次方的排除掉啦
0101 0101 …… 十六进制表示为: 0x55555555
private boolean smartBit(long num){
    return (num > 0) && ((num & (num - 1)) == 0) && ((num & 0x5555555555555555l) == num);
}
    public boolean isPowerOfFour(int num) {
        return num > 0 && (num & (num - 1)) ==0  && (num & 0x55555555) !=0;
    }

https://leetcode.com/discuss/97930/java-1-line-cheating-for-the-purpose-of-not-using-loops
public boolean isPowerOfFour(int num) {
    return (Math.log(num) / Math.log(4)) % 1 == 0;
}

X.
    public boolean isPowerOfFour(int num) {
        return num > 0 && (num&(num-1)) == 0 && (num & 0x55555555) != 0;
        //0x55555555 is to get rid of those power of 2 but not power of 4
        //so that the single 1 bit always appears at the odd position 
    }
http://www.cnblogs.com/grandyang/p/5403783.html
首先根据Power of Two中的解法二,我们知道num & (num - 1)可以用来判断一个数是否为2的次方数,更进一步说,就是二进制表示下,只有最高位是1,那么由于是2的次方数,不一定是4的次方数,比如8,所以我们还要其他的限定条件,我们仔细观察可以发现,4的次方数的最高位的1都是计数位,那么我们只需与上一个数(0x55555555) <==> 1010101010101010101010101010101,如果得到的数还是其本身,则可以肯定其为4的次方数:
    bool isPowerOfFour(int num) {
        return num > 0 && !(num & (num - 1)) && (num & 0x55555555) == num;
    }
https://leetcode.com/problems/power-of-four/discuss/80460/1-line-C%2B%2B-solution-without-confusing-bit-manipulations
The explanation which use (4-1)^n to prove the solution is wrong. Here is why: the (num - 1) % 3 == 0 is used to distinguish the 4^n from 2^n. To prove this code, only prove ((4-1)^n - 1)%3 ==0 is not enough, you also need to prove that (2^n-1)%3 != 0 when n is odd.
Here is my explanation:
The(num - 1) % 3 == 0is used to distinguish the 4^n from 2^n.
2^n = (3-1)^n = C(n,0)3^n(-1)^0+....+(-1)^n.
1.When 2^n is 4^n, which means n is even, in this case, (-1)^n==1 and (2^n-1)%3==0
2.When 2&n is not 4^n, which means n is odd, in this case, (-1)^n=-1 and (2^n-1)%3==1;
This is why we can use(num-1)%3==0 as a condition to sperate 4^n from 2^n.f
或者我们在确定其是2的次方数了之后,发现只要是4的次方数,减1之后可以被3整除
    bool isPowerOfFour(int num) {
        return num > 0 && !(num & (num - 1)) && (num - 1) % 3 == 0;
    }

https://leetcode.com/discuss/97967/java-1-line-of-code-and-can-be-extended-to-any-radix-solution
The idea is that numbers in quaternary system that is power of 4 will be like 10, 100, 1000 and such. Similar to binary case. And this can be extended to any radix.
public boolean isPowerOfFour(int num) {
    return Integer.toString(num, 4).matches("10*");
}
https://leetcode.com/discuss/97926/java-line-solution-using-bitcount-numberoftrailingzeros
public boolean isPowerOfFour(int num) {
    return num>=1 && Integer.bitCount(num) == 1 && Integer.numberOfTrailingZeros(num)%2 == 0;
}
最简单的解法,不断将原数除以4,一旦无法整除,余数不为0,则说明不是4的幂,如果整除到1,说明是4的幂。
private boolean bruteForceMod(long num){
    if(num <= 0) return false;
    while(num % 4 == 0){
        num = num / 4;
    }
    return num == 1;
}
http://www.cnblogs.com/grandyang/p/5403783.html
    bool isPowerOfFour(int num) {
        return num > 0 && int(log10(num) / log10(4)) - log10(num) / log10(4) == 0;
    }
http://www.programcreek.com/2015/04/leetcode-power-of-four-java/
We can use the following formula to solve this problem without using recursion/iteration.
Power of Four
public boolean isPowerOfFour(int num) {
   if(num==0) return false;
 
   int pow = (int) (Math.log(num) / Math.log(4));
   if(num==Math.pow(4, pow)){
       return true;
   }else{
       return false;
   }
}

LeetCode 318 - Maximum Product of Word Lengths


https://leetcode.com/problems/maximum-product-of-word-lengths/
Given a string array words, find the maximum value of length(word[i]) * length(word[j]) where the two words do not share common letters. You may assume that each word will contain only lower case letters. If no such two words exist, return 0.
Example 1:
Given ["abcw", "baz", "foo", "bar", "xtfn", "abcdef"]
Return 16
The two words can be "abcw", "xtfn".
Example 2:
Given ["a", "ab", "abc", "d", "cd", "bcd", "abcd"]
Return 4
The two words can be "ab", "cd".
Example 3:
Given ["a", "aa", "aaa", "aaaa"]
Return 0
No such pair of words.
X.
https://leetcode.com/problems/maximum-product-of-word-lengths/discuss/76976/Bit-shorter-C%2B%2B
还有一种写法,借助哈希表,映射每个mask的值和其单词的长度,每算出一个单词的mask,遍历哈希表里的值,如果和其中的mask值相与为0,则将当前单词的长度和哈希表中存的单词长度相乘并更新结果
Here's an O(n+N) variation, where n is the number of words and N is the total number of characters in all words. Thanks to junhuangli for the suggestion.
int maxProduct(vector<string>& words) {
    unordered_map<int,int> maxlen;
    for (string word : words) {
        int mask = 0;
        for (char c : word)
            mask |= 1 << (c - 'a');
        maxlen[mask] = max(maxlen[mask], (int) word.size());
    }
    int result = 0;
    for (auto a : maxlen)
        for (auto b : maxlen)
            if (!(a.first & b.first))
                result = max(result, a.second * b.second);
    return result;
}
Or: (thanks to junhuangli's further comment)
int maxProduct(vector<string>& words) {
    unordered_map<int,int> maxlen;
    int result = 0;
    for (string word : words) {
        int mask = 0;
        for (char c : word)
            mask |= 1 << (c - 'a');
        maxlen[mask] = max(maxlen[mask], (int) word.size());
        for (auto maskAndLen : maxlen)
            if (!(mask & maskAndLen.first))
                result = max(result, (int) word.size() * maskAndLen.second);
    }
    return result;
}
X.
Build and compute at same time


int maxProduct(vector<string>& words) {
    vector<int> mask(words.size());
    int result = 0;
    for (int i=0; i<words.size(); ++i) {
        for (char c : words[i])
            mask[i] |= 1 << (c - 'a'); //populating the checker array with their respective numbers

        for (int j=0; j<i; ++j)
            if (!(mask[i] & mask[j])) //checking if the two strings have common character
                result = max(result, int(words[i].size() * words[j].size()));
    }
    return result;
}
https://leetcode.com/problems/maximum-product-of-word-lengths/discuss/76959/JAVA-Easy-Version-To-Understand!!!!!!!!!!!!!!!!!
https://leetcode.com/problems/maximum-product-of-word-lengths/discuss/77021/32ms-Java-AC-solution
    public int maxProduct(String[] words) {
        int max = 0;

        Arrays.sort(words, new Comparator<String>(){
            public int compare(String a, String b){
                return b.length() - a.length();
            }
        });

        int[] masks = new int[words.length]; // alphabet masks

        for(int i = 0; i < masks.length; i++){
            for(char c: words[i].toCharArray()){
                masks[i] |= 1 << (c - 'a');
            }
        }
    
        for(int i = 0; i < masks.length; i++){
            if(words[i].length() * words[i].length() <= max) break; //prunning
            for(int j = i + 1; j < masks.length; j++){
                if((masks[i] & masks[j]) == 0){
                    max = Math.max(max, words[i].length() * words[j].length());
                    break; //prunning
                }
            }
        }

        return max;
    }
http://traceformula.blogspot.com/2015/12/maximum-product-of-word-lengths.html
https://discuss.leetcode.com/topic/35539/java-easy-version-to-understand
https://discuss.leetcode.com/topic/31769/32ms-java-ac-solution
https://zyfu0408.gitbooks.io/interview-preparation/content/bit-manipulation/storer-information-by-bit.html
If you first read the problem, you can think of brute force solution: for each pair of words, check whether they have a common letter, if not, get the product of their lengths and compare to max value achieved so far.
The brute force solution leads to another requirement: checking a pair of words if they contain common letters? Actually, we can do that with some pre-calculation, and with the understanding that the words contain only lowercase letters.
Since there are only 26 lowercase letters, we can represent a set of letters using an integer. So let's say if the word contains 'a', then the integer's 0th bit will be 1. If it has 'b', then the 1st is set to 1, so on and so forth.
  1.     public int maxProduct(String[] words) {  
  2.         int n = words.length;  
  3.         int[] dietpepsi = new int[n];  
  4.         for(int i=0; i<n; i++){  
  5.             dietpepsi[i] = getMask(words[i]);  
  6.         }  
  7.         int max = 0; int t;  
  8.         for(int i=0; i<n; i++){  
  9.             t = 0;  
  10.             for(int j=i+1; j<n; j++){  
  11.                 if((dietpepsi[i] & dietpepsi[j]) == 0){  
  12.                     t = Math.max(t, words[j].length());  
  13.                 }  
  14.             }  
  15.             max = Math.max(max, t*words[i].length());  
  16.         }  
  17.         return max;  
  18.     }  
  19.     private int getMask(String s){  
  20.         int mask = 0;  
  21.         for(char c: s.toCharArray()){  
  22.             mask |= 1 << (c - 'a');  
  23.         }  
  24.         return mask;  
  25.     }  
II. Improvement on (I) 
We can make some improvement by first sorting the words according to their lengths. Then for the ith word in the sorted array, we check from i-1 to 0 to see if there is a word that shares no common letter with it. Then we calculate the product, compare to the max value so far, stop the loop for the ith word, and move on with the (i+1)th word.
  1.     public int maxProduct(String[] words) {  
  2.         int n = words.length;  
  3.           
  4.         Arrays.sort(words, new LengthComparator());  
  5.         int[][] dietpepsi = new int[n][2];  
  6.         int max = 0;  
  7.         for(int i=0; i<n; i++){  
  8.             dietpepsi[i][0] |= getMask(words[i]);   
  9.             dietpepsi[i][1] = words[i].length();  
  10.         }  
  11.           
  12.         int last = 0;  
  13.         for(int i=n-1; i>=1; i--){  
  14.             for(int j=i-1; j>=last; j--){  
  15.                 if((dietpepsi[i][0] & dietpepsi[j][0]) == 0){  
  16.                     max = Math.max(dietpepsi[i][1] * dietpepsi[j][1], max);  
  17.                     last = j;  
  18.                     while(last<n && dietpepsi[last][1]==dietpepsi[j][1]) last++;  
  19.                     break;  
  20.                 }  
  21.             }  
  22.         }  
  23.         return max;  
  24.     }  
  25.     private int getMask(String s){  
  26.         int mask = 0;  
  27.         for(char c: s.toCharArray()){  
  28.             mask |= 1 << (c - 'a');  
  29.         }  
  30.         return mask;  
  31.     }  
  32.     class LengthComparator implements Comparator<String>{  
  33.         public int compare(String a, String b){  
  34.             return a.length() - b.length();  
  35.         }  
  36.     }  
http://segmentfault.com/a/1190000004186943
然而我们可以简化对于两个单词求product这一步,方法是我们做个预处理,遍历一遍单词,对于每个单词,我们用一个Integer表示其含有的字母情况。预处理之后,对于两个单词我们只需要对两个int做个和运算便可以知道两个单词是否存在相同字母。这种方法,我们可以将时间复杂度降到O(n^2)。
当然,在以上方法的基础上,我们可以做一些小优化,比如事先对单词根据长度依照长度从大到小排序,这样在两个for loop过程中我们可以根据具体情况直接跳出,不用再继续遍历
    public int maxProduct(String[] words) {
        int[] maps = new int[words.length];
        
        // 将单词按照长度从长到短排序
        Arrays.sort(words, new Comparator<String>() {
           public int compare(String s1, String s2) {
               return s2.length() - s1.length();
           } 
        });
        
        // 对于每个单词,算出其对应的int来表示所含字母情况
        for (int i = 0; i < words.length; i++) {
            int bits = 0;
            for (int j = 0; j < words[i].length(); j++) {
                char c = words[i].charAt(j);
                // 注意bit运算优先级
                bits = bits | (1 << (c - 'a'));
            }
            maps[i] = bits;
        }
        
        int max = 0;
        for (int i = 0; i < words.length; i++) {
            // 提前结束,没必要继续loop
            if (words[i].length() * words[i].length() <= max)
                break;
            for (int j = i + 1; j < words.length; j++) {
                if ((maps[i] & maps[j]) == 0) {
                    max = Math.max(max, words[i].length() * words[j].length());
                    // 下面的结果只会更小,没必要继续loop
                    break;
                }
            }
        }
        return max;
    }
https://leetcode.com/discuss/74589/32ms-java-ac-solution

http://www.hrwhisper.me/leetcode-maximum-product-of-word-lengths/
直接看看每个字符串都包括了哪个字符,然后一一枚举是否有交集:
有交集,则乘积为0
无交集,乘积为 words[i].length() * words[j].length()
int maxProduct(vector<string>& words) {
int n = words.size();
vector<vector<int> > elements(n, vector<int>(26, 0));
for (int i = 0; i < n; i++) {
for (int j = 0; j < words[i].length(); j++)
elements[i][words[i][j] - 'a'] ++;
}
int ans = 0;
for (int i = 0; i < n; i++) {
for (int j = i + 1; j < n; j++) {
bool flag = true;
for (int k = 0; k < 26; k++) {
if (elements[i][k] != 0 && elements[j][k] != 0) {
flag = false;
break;
}
}
if (flag && words[i].length() * words[j].length()  > ans)
ans = words[i].length() * words[j].length();
}
}
return ans;
}
https://leetcode.com/discuss/74528/bit-manipulation-java-o-n-2
Pre-process the word, use bit to represent the words. We can do this because we only need to compare if two words contains the same characters.
public int maxProduct(String[] words) { int max = 0; int[] bytes = new int[words.length]; for(int i=0;i<words.length;i++){ int val = 0; for(int j=0;j<words[i].length();j++){ val |= 1<<(words[i].charAt(j)-'a'); } bytes[i] = val; } for(int i=0; i<bytes.length; i++){ for(int j=i+1; j<bytes.length; j++){ if((bytes[i] & bytes[j])==0)max = Math.max(max,words[i].length()*words[j].length()); } } return max; }
https://leetcode.com/discuss/74519/straightforward-o-n-2-solution-by-comparing-each-word
http://buttercola.blogspot.com/2016/01/leetcode-maximum-product-of-word-lengths.html
The most straight-forward way to solve this problem is to pick up any two words, and check if they have common characters. If not, then calculate the maximum product of the length. 

Now let's analyze the complexity in time. Suppose the number of words is n, and average word length is m. So the time complexity for the  brute-force solution is O(n^2 * m). 
Straightforward O(n^2) solution by comparing each word
public int maxProduct(String[] words) { if (words == null || words.length == 0) return 0; int result = 0; for (int i = 0; i < words.length; i++) { int[] letters = new int[26]; for (char c : words[i].toCharArray()) { letters[c - 'a'] ++; } for (int j = 0; j < words.length; j++) { if (j == i) continue; int k = 0; for (; k < words[j].length(); k++) { if (letters[words[j].charAt(k) - 'a'] != 0) { break; } } if (k == words[j].length()) { result = Math.max(result, words[i].length() * words[j].length()); } } } return result; }
http://bookshadow.com/weblog/2015/12/16/leetcode-maximum-product-word-lengths/

class Solution(object): def maxProduct(self, words): """ :type words: List[str] :rtype: int """ nums = [] size = len(words) for w in words: nums += sum(1 << (ord(x) - ord('a')) for x in set(w)), ans = 0 for x in range(size): for y in range(size): if not (nums[x] & nums[y]): ans = max(len(words[x]) * len(words[y]), ans) return ans

另一种解法:

引入辅助数组es和字典ml。
es[x]记录所有不包含字母x的单词(单词转化成的数字)
ml[x]记录所有单词对应数字的最大长度
首次遍历words,计算words[i]对应的数字num,并找出words[i]中所有未出现的字母,将num加入这些字母在es数组中对应的位置。
二次遍历words,计算words[i]中未出现过字母所对应的数字集合的交集,从字典ml中取长度的最大值进行计算。
def maxProduct(self, words): """ :type words: List[str] :rtype: int """ es = [set() for x in range(26)] ml = collections.defaultdict(int) for w in words: num = sum(1 << (ord(x) - ord('a')) for x in set(w)) ml[num] = max(ml[num], len(w)) for x in set(string.lowercase) - set(w): es[ord(x) - ord('a')].add(num) ans = 0 for w in words: r = [es[ord(x) - ord('a')] for x in w] if not r: continue r = set.intersection(*r) for x in r: ans = max(ans, len(w) * ml[x]) return ans

https://www.hrwhisper.me/leetcode-maximum-product-of-word-lengths/
直接看看每个字符串都包括了哪个字符,然后一一枚举是否有交集:
  • 有交集,则乘积为0
  • 无交集,乘积为 words[i].length() * words[j].length()
int maxProduct(vector<string>& words) {
    int n = words.size();
    vector<vector<int> > elements(n, vector<int>(26, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < words[i].length(); j++)
            elements[i][words[i][j] - 'a'] ++;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            bool flag = true;
            for (int k = 0; k < 26; k++) {
                if (elements[i][k] != 0 && elements[j][k] != 0) {
                    flag = false;
                    break;
                }
            }
            if (flag && words[i].length() * words[j].length()  > ans)
                ans = words[i].length() * words[j].length();
        }
    }
    return ans;
}

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts